#!/usr/bin/perl
use rIML;
$|=1;

%prices= (potato=>6,onion=>20,beans=>10,tomato=>2,carrot=>8);
%index = (potato=>1,onion=>2,beans=>3,tomato=>4,carrot=>5);
%speakdata=  (
          potato=> "2 l6 g7dd dd8 G3000 b7 l8 G10000 2 r5 G3000 r5 p1y G10000\n",
	  onion=> "4 r5 ll ll4 G3000 b7 l8 G10000 3p p1t t5 G3000 r5 p1y G10000\n",     
	  beans=> "b4n 0s G3000 b7 l8 G10000 h1t t5 G3000 r5 p1y G10000\n",     
	  tomato=> "tt11 m9 tt12 G3000 b7 l8 G10000 7 r1 dd5 G3000 r5 p1y G10000\n",     
	  carrot=> "k9 r1tt G3000 b7 l8 G10000 7n tt5 G3000 r5 p1y G10000\n",     
	  );
	  
        my $hash=rIML->read();
        if(!$hash){
                print "<page>Error!</page>";
                exit
        }
        my $what=$hash->{var1};
        my $where=$index{$what};
        my $price=$prices{$what};
        my $speak=$speakdata{$what};
        
print <<EOF;
<iml><page>
<image id="img"  mode="create" width="240" height="280" />
<image id="img1" tagid="img" mode="src"  anchor="_prev"  
audioformat="tts" speak="$speak"
src="images/curr.gif"/>
<image id="img2" tagid="img"  mode="draw" draw="rect" fill="#ffffff" 
coord="70,220,150,250"/>
<image id="img2" tagid="img"  mode="draw" draw="text" text="Rs $price" 
font="1"  coord="110,235"/>
</page>
</iml>
EOF


