package History; # Singleton


#
# data str: [[items, ...],[curr_ptr,total_length]]
#

@History=([],[0,0]);

sub add {
	my $self=shift;
	my $val=shift;
	my ($arr,$counters)=@$self;
	my $curr_pos=$counters->[0];
	$arr->[$curr_pos]=$val;
	$curr_pos++;
        splice @$arr,$curr_pos unless ($curr_pos==$counters->[1]);
	$counters->[0]=$curr_pos;
	$counters->[1]=$curr_pos;
	1;
}

sub first {
	my $self=shift;
	my ($arr,$counters)=@$self;
	$counters->[0]=1;
	return $arr->[0];
}

sub current {
	my $self=shift;
	my ($arr,$counters)=@$self;
	my $curr_pos=$counters->[0];
	return $arr->[$curr_pos-1];
}

sub back {
	my $self=shift;
	my ($arr,$counters)=@$self;
	my $curr_pos=$counters->[0];
	if ($curr_pos>=2) {
		$curr_pos--;
	}
	$counters->[0]=$curr_pos;
	return $arr->[$curr_pos-1];
}

sub forward {
	my $self=shift;
	my ($arr,$counters)=@$self;
	my $curr_pos=$counters->[0];
	if ($curr_pos < $counters->[1]) {
		$curr_pos++
	}
	$counters->[0]=$curr_pos;
	return $arr->[$curr_pos-1];
}

sub max {
        my $self=shift;
	my ($arr,$counters)=@$self;
        return $counters->[1];
}

sub page_no {
        my $self=shift;
	my ($arr,$counters)=@$self;
        return $counters->[0];
}

sub random_access {
        my $self=shift;
	my $page_no=shift;
	my ($arr,$counters)=@$self;
	if(($page_no >=1) && ($page_no <= $counters->[1])){
	        $counters->[0]=$page_no;
                return $arr->[$page_no-1];
	}else{
	        $counters->[0]=1;	
	        return $arr->[0];
	}
}


sub trace {
	my $self=shift;
	my ($arr,$counters)=@$self;
	print "[ @$arr ][ @$counters]\n";
}

1;
