package sCode;

sub encode {
        my ($self, $hash, $elems)=@_;
        my @keys=sort (keys %{$hash});
        my $rows=@keys;
        my $cols=$elems+1;
        my $out = "S[$rows,$cols:";
        for my $k (@keys){
                $out .= length($k).":".$k;
                if($elems >1){
                        my @arr=@{$hash->{$k}};
                        if(@arr != $elems){
                                return undef
                        }
                        for(@arr){
                                $out .= length($_).":".$_;
                        }
                        next;
                }
                if($elems==1){
                        my $e=$hash->{$k};
                        $out .= length($e).":".$e;
                        next
                }
                return undef;
        }
        return $out
}       

sub decode {
        my ($self, $coded)=@_;
        my %h=();
        my ($r, $c)=($coded=~/^S\[(\d+),(\d+):/);
        $coded=$';
        my $i,$k;
        for($i=0;$i<$r; $i++){
                my @row=();                
                for($j=0;$j<$c; $j++){
                        if(!$coded){
                                return undef
                        }        
                        my ($len) = ($coded=~/^(\d+):/);
                        $coded=$';
			if ($len == 0) {
				next
			}
                        if(!$len){
                                return undef
                        }
                        my $cell= substr($coded, 0, $len);
                        if(length($cell)!=$len){
                                return undef
                        }        
                        push @row, $cell;
                        $coded=substr($coded, $len);
                }
                my $key=shift @row;
                if($c==2){
                        $h{$key}=shift @row
                }else{        
                        $h{$key}=\@row;
                }        
        }
        if($coded){
                return undef                
        }        
        return \%h;
}

1;
